clear

MS=104.15;
MD=130.19;
ds= 909; //g/L
dd= 910;
//  yvd  

Pn=[4];

for g=1:length(Pn)

CI= [15];

for l=1:length(CI)

// BC: 2,5L de fase organica

yvd=CI(l)/100;
yvh= 0.5;
VD= 1*yvd;
VS=1*(1-yvd);
VH= 1.5*yvh;
VT= 1.5*(1-yvh);




t0=0;
    deltat=[0:100:108000]; 
    
    M20=VD*dd/(2.5*MD);
    M10=VS*ds/(2.5*MS); //mol/L
    I0=0.01*(M20+M10);
    
    
    Ro0=0; // mol/L
    R0=0; // mol/L
    PDB0=0;
    RP0=0;
    
    
    n= Pn(g);
    
    disp([n CI(l)])
    
    for i=1:n
        LA0(i)=0;
        LB0(i)=0;
        LC0(i)=0;
        LD0(i)=0;
        LE0(i)=0;
    end
    
    
  
    
    C0=[I0;M10;M20;Ro0;R0;PDB0;RP0;LA0;LB0;LC0;LD0;LE0]; 
        
        
        function dCdt=edoCDD(t, C)
            
            I=C(1);
            M1=C(2);
            M2=C(3);
            Ro=C(4);
            R=C(5);
            PDB=C(6);
            RP=C(7);
            
            if (M10-M1)==0 then
            U1=M10;
            U2=M20;
            else
            U1=M10-M1;
            U2=M20-M2;
            end
            
            
            
          
            
            for i=1:n
                LA(i)=C(7+i);
                LB(i)=C(7+n+i);
                LC(i)=C(7+2*n+i);
                LD(i)=C(7+3*n+i);
                LE(i)=C(7+4*n+i);
                
            end
            
            T= 363;
           // kd= 4.31e15*exp(-131700/(8.314*T)); //AIBN f=0,6
            kd= 6.94e13*exp(-122300/(8.314*T));
            kp11=4.27e7*exp(-32500/(8.314*T));
            kp12=kp11/(0.7*0.43+0.3*0.24);
            
            
            
            kp21=0.77*kp11;
            kp22=0.77*kp12;
            
            kp1= U1*kp11+U2*kp21/(U1+U2);
            kp2= U1*kp12+U2*kp22/(U1+U2);
            
            ki1=kp11;
            ki2=kp12;
            kt=(kp1/(426.4*exp(-26000/(8.314*T))))^2;
            f= 0.55;
                        
            CP=0.2
            
            r12= 0.43;
            r13= 0.24;
            
            kp1m=CP*kp11/(2*r12);
            kp1p=CP*kp11/(2*r13);
            kp2m= 0.77*kp1m;
            kp2p= 0.77*kp1p;
            
            kp13= 0.70*kp1m+0.3*kp1p;
            kp23= 0.70*kp2m+0.3*kp2p;
            
            
            
            
            kp3=(kp13*U1+kp23*U2)/(U1+U2);            
//            kp3c3=3.31e7*exp(-32500/(8.314*T))           
                       
                        
            SA=sum(LA(1:n));  
            SB=sum(LB(1:n));
            SC=sum(LC(1:n));
            SD=sum(LD(1:n));
            //SE=sum(LE(1:n));          
            
        
            dIdt= -kd*I;
            dRodt= 2*f*kd*I-ki1*Ro*M1-ki2*Ro*M2-kp3*Ro*PDB;
            dRdt= ki1*Ro*M1-kt*R^2-kp2*R*M2-kt*R*(SA+SC)-kp3*R*(SA+2*SB+SD);
            dM1dt= -ki1*Ro*M1-kp1*RP*M1;
            dM2dt= -ki2*Ro*M2-kp2*RP*M2;
            dPDBdt= ki2*Ro*M2+kp2*RP*M2-kp3*PDB*(Ro+RP);
            dRPdt= ki1*Ro*M1+ki2*Ro*M2-kt*RP^2;
            
            //Tamanho Zero (n=1)
            dLAdt(1)= ki2*Ro*M2+kp2*M2*(SA+SC+R)-LA(1)*(kp1*M1+kp2*M2+kt*(SA+SC+Ro+R)+kp3*(SA+2*SB+SC+SD+Ro+R));
            dLBdt(1)= kp2*LA(1)*M2+kt*(LA(1))^2/2-2*kp3*LB(1)*(SA+SC+Ro+R);
            dLCdt(1)=-kp1*LC(1)*M1-kp2*LC(1)*M2-kt*LC(1)*(SA+SC+R)-kp3*LC(1)*(SA+2*SB+SD)+kp3*SA*(2*SA+2*SB+SC+SD+Ro+R)+2*kp3*SB*(SC+Ro+R)+kp3*SD*(SC+Ro+R);
            dLDdt(1)= kp2*M2*LC(1)+kt*LA(1)*LC(1)+kp3*LA(1)*(SA+SD)+2*kp3*LB(1)*(SA+SC+Ro+R)-kp3*LD(1)*(SA+SC+Ro+R);
            dLEdt(1)=kp3*LC(1)*(SA+2*SB+SD)+kp3*LD(1)*(SA+Ro+R)+kt*(LC(1))^2/2;
            
            // Tamanhos 2 a n
            for r=2:n
                for s=1:r-1
                SLAA= LA(s)*LA(r-s);
                SLAC= LA(s)*LC(r-s);
                SLCC= LC(s)*LC(r-s);
                end
//            kp3cr(1)=0
//            kp3cr(2)=0  
//            if r>2
//            kp3cr(r)=kp3c3*(2/(r-1))^1.5  
//        end
        
            dLAdt(r)=kp1*M1*LA(r-1)-kp1*M1*LA(r)-kp2*M2*LA(r)-kt*LA(r)*(SA+SC+R)-kp3*LA(r)*(SA+2*SB+SC+SD+Ro+R);
            dLBdt(r)=kp2*M2*LA(r)+kt* SLAA/2-2*kp3*LB(r)*(SA+SC+Ro+R);
            dLCdt(r)= kp1*M1*LC(r-1)-kp1*M1*LC(r)-kp2*M2*LC(r)-kt*LC(r)*(SA+SC+R)-kp3*LC(r)*(SA+2*SB+SD)+kp3*LA(r)*(SA+SC+Ro+R);
            dLDdt(r)= kp2*M2*LC(r)+kt*SLAC+kp3*LA(r)*(SA+2*SB+SD)+2*kp3*LB(r)*(SC+Ro+R)-kp3*LD(r)*(SA+SC+Ro+R);
            dLEdt(r)=kp3*LC(r)*(SA+2*SB+SD)+kp3*LD(r)*(SA+Ro+R)+kt*SLCC/2;
            end
            
           
            
dCdt=[dIdt;dM1dt;dM2dt;dRodt;dRdt;dPDBdt;dRPdt;dLAdt;dLBdt;dLCdt;dLDdt;dLEdt];
            
        endfunction
        
        C=ode(C0,t0,deltat,edoCDD)';
        
        I=C(:,1);
        M1=C(:,2);
        M2=C(:,3);
        Ro=C(:,4);
        R=C(:,5);
        PDB=C(:,6);
        RP=C(:,7);
        
        for h=1:n
            LA(:,h)=C(:,7+h)
            LB(:,h)=C(:,7+n+h)
            LC(:,h)=C(:,7+2*n+h)
            LD(:,h)=C(:,7+3*n+h)
            LE(:,h)=C(:,7+4*n+h)
        end
        
        CLE(:,l)=LE(length(LE(:,1)),:)'
        YLE(:,l)=CLE(:,l)/(sum(CLE(:,l)))
        
        for j=1:length(deltat)
        
        U1(j)=(M10-M1(j));
        U2(j)=(M20-M2(j));
        MM(j)=(U1(j)*MS+U2(j)*MD)/(U1(j)+U2(j));
        
        DVB(j)=U2(j)/(U1(j)+U2(j));
        CLP(j)=M20-M2(j)-PDB(j);
        YCLt(j)=CLP(j)/(U1(j)+U2(j));
        
        SMC(j,1)=LE(j,1)*1*130.19;
        for k=2:n
        SMC(j,k)=LE(j,k)*k*104.15;
        end
       MCt(j)=(sum(SMC(j,1:n)))/(sum(LE(j,1:n)));
        
    end
    
    //MC(l)=MCt(length(deltat));
    YCL(l)=YCLt(length(deltat));
    MC(l)=(1/YCL(l))*MM(length(deltat));
    
    disp(YLE) 
    end
    
//   disp([MC; YCL])
   PMC(:,g)=MC;
   PYCL(:,g)=YCL;
   
   end
 
   
   disp(PMC)  
       
      
// plot(MCexp(:,1),MCexp(:,2),'o',CI,PMC,'-')
