clear
//dados de entrada

wr=0.99999
wp=1-wr
SIexp= 3.82957

MC= 5850

dif2=1
tol=1e-6

while dif2>tol

MC=MC+1
K=1.15
dif=1
while dif>tol

K= K+0.0001


ur=0.3975
up=0.3527
ror= 1.1
ros=0.867
rop=1.005
V1= 106.2745


//função
function za=ESTIMCA(vr)
    
    za= log(1-vr)+vr+ur*vr^2+ror*V1*vr^(1/3)/(MC*K^(4/3))
    
endfunction

// resolvendo com fsolve
vri= 0.28
[vropt]=fsolve(vri,ESTIMCA)

function zb=ESTIMCB(vp)
    
    zb= log(1-vropt)+vropt+ur*vropt^2+ror*V1*vropt^(1/3)*(1+2*K^2)/(3*MC*K^(4/3))+(((K+1)^2+2*K^3)/(2*((K+1)^3-K^3)))*(log(1-vp)+vp+up*vp^2)
    
endfunction

// resolvendo com fsolve
vpi= 0.01
[vpopt]=fsolve(vpi,ESTIMCB)

//disp('K=')
//disp(vropt/vpopt)

Kcalc= vropt/vpopt
dif= (K-Kcalc)^2

end

SI= 1+(ros*wr/ror*(1/vropt-1)+ros*wp/rop*(1/vpopt-1))/(wr+wp)


dif2=(SI-SIexp)^2

disp(SI)

end

disp(MC)
