clear

// DADOS Durie 2002

MS=104.15;
MD=130.19;
ds= 909; //g/L
dd= 910;
//  yvd  

Pn=[3];

for g=1:length(Pn)
    
// DVB  U   AIBN         Csty       CDVB       sulobparR    
//CI= [2	4.4	0.055357163	8.553428506	0.139655858  15.75       
//3	2.9	0.055357772	8.466241661	0.209486089       15.6        
//4	2.7	0.05535838	8.3790529	0.279317855      15.7       
//5	2.1	0.055358988	8.291862222	0.349151155       15.6        
//40	1.4	0.027690145	2.619490359	1.397142013      16.6        
//50	1.2	0.027693189	2.183148644	1.746619537      16.5       
//60	0.9	0.027696235	1.746710967	2.096173919      16.0   ];   //18.72

CI=[5	2.1	0.055358988	8.291862222	0.349151155       15.6]


for l=1:length(CI(:,1))

t0=0;
    deltat=[0:100:18000]; 
    
  
        I0= CI(l,3) //mol/L
    M10=CI(l,4)  //mol/L
  M20= CI(l,5)   //mol/L

    
        Ro0=0; // mol/L
    R0=0; // mol/L
    PDB0=0;
    RP0=0;
    RL0= 0
    PL0= 0
    PT0= 0
    PDBc0=0
    
    n= Pn(g);
    
    
    for i=1:n
        LA0(i)=0;
        LB0(i)=0;
        LC0(i)=0;
        LD0(i)=0;
        LE0(i)=0;
    end
    
    
    C0=[I0;M10;M20;Ro0;R0;PDB0;RP0;RL0;PL0;PT0;LA0;LB0;LC0;LD0;LE0;PDBc0]; 
        
        
        function dCdt=edoCDD(t, C)
            
            I=C(1);
            M1=C(2);
            M2=C(3);
            Ro=C(4);
            R=C(5);
            PDB=C(6);
            RP=C(7);
            RL= C(8)
            PL= C(9)
            PT= C(10)
            PDBc=C(11)
            
            if (M10-M1)==0 then
            U1=M10;
            U2=M20;
            else
            U1=M10-M1;
            U2=M20-M2;
            end
            
                        
            for i=1:n
                LA(i)=C(11+i);
                LB(i)=C(11+n+i);
                LC(i)=C(11+2*n+i);
                LD(i)=C(11+3*n+i);
                LE(i)=C(11+4*n+i);
                
            end
            
            T= 353;
            kd= 4.31e15*exp(-131700/(8.314*T)); //AIBN f=0,6
//            kd= 6.94e13*exp(-122300/(8.314*T));  // BPO
            kp11=4.27e7*exp(-32500/(8.314*T));
            kp12=kp11/(0.7*0.43+0.3*0.24);
            
            
            
            kp21=0.77*kp11;
            kp22=0.77*kp12;
            
            kp1= U1*kp11+U2*kp21/(U1+U2);
            kp2= U1*kp12+U2*kp22/(U1+U2);
            
            ki1=kp11;
            ki2=kp12;
            kt=(kp1/(426.4*exp(-26000/(8.314*T))))^2;
            f= 0.6;
                        
            CP=0.2
            
            r12= 0.43;
            r13= 0.24;
            
            kp1m=CP*kp11/(2*r12);
            kp1p=CP*kp11/(2*r13);
            kp2m= 0.77*kp1m;
            kp2p= 0.77*kp1p;
            
            kp13= 0.70*kp1m+0.3*kp1p;
            kp23= 0.70*kp2m+0.3*kp2p;
            
            
            
            kp3=(kp13*U1+kp23*U2)/(U1+U2);            
//            kp3c3=3.31e7*exp(-32500/(8.314*T))           
                       
                        
            SA=sum(LA(1:n));  
            SB=sum(LB(1:n));
            SC=sum(LC(1:n));
            SD=sum(LD(1:n));
            
            //SE=sum(LE(1:n));          
            
            kcycr(1)=0
            kcycr(2)=0  
            kcyc3=460
            
            for j=3  
            kcycr(j)=kcyc3*(2/(j-1))^1.5  
            CYC(j)= kcycr(j)*LA(j)
        end
        
        SCYC= sum(CYC)
        
            dIdt= -kd*I;
            dRodt= 2*f*kd*I-ki1*Ro*M1-ki2*Ro*M2-kp3*Ro*PDB;
            dRdt= ki1*Ro*M1-kt*R^2-kp2*R*M2-kt*R*(SA+SC)-kp3*R*(SA+2*SB+SD);
            dM1dt= -ki1*Ro*M1-kp1*RP*M1;
            dM2dt= -ki2*Ro*M2-kp2*RP*M2;
            dPDBdt= ki2*Ro*M2+kp2*RP*M2-kp3*PDB*(Ro+RP)-SCYC;
            dRPdt= ki1*Ro*M1+ki2*Ro*M2-kt*RP^2;
            dRLdt= ki1*Ro*M1-kp2*RL*M2-kp3*RL*PDB - kt*RL^2
            dPLdt= (kt*RL^2)/2
            dPTdt= (kt*RP^2)/2
            dPDBcdt= SCYC
           
                      
           
                        
            //Tamanho Zero (n=1)
            dLAdt(1)= ki2*Ro*M2+kp2*M2*(SA+SC+R)-LA(1)*(kp1*M1+kp2*M2+kt*(SA+SC+Ro+R)+kp3*(2*SA+2*SB+SC+SD+Ro+R));
            dLBdt(1)= kp2*LA(1)*M2+kt*(LA(1))^2/2-2*kp3*LB(1)*(SA+SC+Ro+R);
            dLCdt(1)=-kp1*LC(1)*M1-kp2*LC(1)*M2-kt*LC(1)*(SA+SC+R)-kp3*LC(1)*(SA+2*SB+SD)+kp3*SA*(2*SA+2*SB+SC+SD+Ro+R)+2*kp3*SB*(SC+Ro+R)+kp3*SD*(SC+Ro+R)+SCYC;
            dLDdt(1)= kp2*M2*LC(1)+kt*LA(1)*LC(1)+kp3*LA(1)*(SA+2*SB+SD)+2*kp3*LB(1)*(SA+SC+Ro+R)-kp3*LD(1)*(SA+SC+Ro+R);
            dLEdt(1)=kp3*LC(1)*(SA+2*SB+SD)+kp3*LD(1)*(SA+SC+Ro+R)+(kt*(LC(1))^2)/2;
            
            // Tamanhos 2 a n
            for r=2:n
                for s=1:r-1
                SLAA= LA(s)*LA(r-s);
                SLAC= LA(s)*LC(r-s);
                SLCC= LC(s)*LC(r-s);
                end

        
            dLAdt(r)=kp1*M1*LA(r-1)-kp1*M1*LA(r)-kp2*M2*LA(r)-kt*LA(r)*(SA+SC+R)-kp3*LA(r)*(2*SA+2*SB+SC+SD+Ro+R)-kcycr(r)*LA(r);
            dLBdt(r)=kp2*M2*LA(r)+0.5*kt*SLAA/2-2*kp3*LB(r)*(SA+SC+Ro+R);
            dLCdt(r)= kp1*M1*LC(r-1)-kp1*M1*LC(r)-kp2*M2*LC(r)-kt*LC(r)*(SA+SC+R)-kp3*LC(r)*(SA+2*SB+SD)+kp3*LA(r)*(SA+SC+Ro+R);
            dLDdt(r)= kp2*M2*LC(r)+kt*SLAC+kp3*LA(r)*(2*SB+SD+SA)+2*kp3*LB(r)*(SA+SC+Ro+R)-kp3*LD(r)*(SA+SC+Ro+R);
            dLEdt(r)=kp3*SA*(LD(r)+LC(r))+kp3*LC(r)*(2*SB+SD)+kp3*LD(r)*(SC+Ro+R)+0.5*kt*SLCC/2
            end
            
                       
dCdt=[dIdt;dM1dt;dM2dt;dRodt;dRdt;dPDBdt;dRPdt;dRLdt;dPLdt;dPTdt;dPDBcdt;dLAdt;dLBdt;dLCdt;dLDdt;dLEdt];
            
        endfunction
        
        C=ode(C0,t0,deltat,edoCDD)';
        
        I=C(:,1);
        M1=C(:,2);
        M2=C(:,3);
        Ro=C(:,4);
        R=C(:,5);
        PDB=C(:,6);
        RP=C(:,7);
        RL= C(:,8);
        PL= C(:,9);
        PT= C(:,10)
        PDBc=C(:,11)
        
        for h=1:n
            LA(:,h)=C(:,11+h)
            LB(:,h)=C(:,11+n+h)
            LC(:,h)=C(:,11+2*n+h)
            LD(:,h)=C(:,11+3*n+h)
            LE(:,h)=C(:,11+4*n+h)
        end
        
        CLE(:,l)=LE(length(LE(:,1)),:)'
        YLE(:,l)=CLE(:,l)/(sum(CLE(:,l)))
        
        
        for j=1:length(deltat)
        
        U1(j)=(M10-M1(j));
        U2(j)=(M20-M2(j));
        MM(j)=(U1(j)*MS+U2(j)*MD)/(U1(j)+U2(j));
        
        DVB(j)=U2(j)/(U1(j)+U2(j));
        CLP(j)=M20-M2(j)-PDB(j)-PDBc(j);
        YCLt(j)=CLP(j)/(U1(j)+U2(j));
        YPLt(j,l)=PL(j)/(PT(j))
        
        SMC(j,1)=LE(j,1)*1*130.19;
        for k=2:n
        SMC(j,k)=LE(j,k)*k*104.15;
        end
       MCt(j)=(sum(SMC(j,1:n)))/(sum(LE(j,1:n)));
        
    end
    
    //MC(l)=MCt(length(deltat));
    YCL(l)=YCLt(length(deltat));
    YPL(l)=YPLt(length(deltat),l);
    MC(l)=(1/YCL(l))*MM(length(deltat));
    
 
    end
    

   PMC(:,g)=MC;
   PYCL(:,g)=YCL;
   
   end
 
   disp([PMC YPL])  
   
   //  Cálculo do Swelling Index
   
   for j= 1:length(PMC) 
   
   
//wr= YCI(j,7) //0.9999999999
//wp=1-wr

wp= YPL(j)
wr= 1-wp

T= 303
MC= PMC(j)

// Parâmetros de solubilidade
deltasolv= 33.8 // ethanol // 47.9 //water//33.8 // Glycerol// 20.1   // Acetone
deltap= 25.86 //41.3 //18.72 // polimero   18.72 (ñ sulf)
deltar=  21.86 //41.3 //15.7 // resina      15.7 (ñ sulf)


V1= 87.45 //56.71 //ethanol // 22.1 //water //87.45 //glycerol //77.6 //acetone   // mL/mol
up= 0.34+V1*(deltap-deltasolv)^2/(8.314*T)  
ur= 0.34+V1*(deltar-deltasolv)^2/(8.314*T)  
ror= 1.315
ros= 1.26 //0.789 // ethanol // 1 // water //1.26 // glycerol //0.784 //acetone
rop=1.315

//MM=60.576


function zb=ESTIMCB(vr)
    
    K=(-(ror*V1*vr^(1/3))/(MC*(log(1-vr)+vr+ur*vr^2)))^(3/4)
    vp=vr/K
    zb= log(1-vr)+vr+ur*vr^2+ror*V1*vr^(1/3)*(1+2*K^2)/(3*MC*K^(4/3))+(((K+1)^2+2*K^3)/(2*((K+1)^3-K^3)))*(log(1-vp)+vp+up*vp^2) //(B)
    
endfunction

// resolvendo com fsolve
Sw=(-1)^0.5
vri= 0.0001

while ~isreal(Sw)


[vropt]=fsolve(vri,ESTIMCB)

K=(-(ror*V1*vropt^(1/3))/(MC*(log(1-vropt)+vropt+ur*vropt^2)))^(3/4)

vpopt=vropt/K


Sw= 1+(ros*wr/ror*(1/vropt-1)+ros*wp/rop*(1/vpopt-1))/(wr+wp)

SI=(Sw-1)*ror/ros

vri=vri+0.0001

//disp(vri)

end

U(j) = (Sw-1)/ros

end
disp([Sw SI])

// 
// subplot(1,2,1)     
// bar(CI(1:4,1)',[CI(1:4,2) U(1:4)]) 
// xlabel("% DVB")
// ylabel("Swelling Index (vol)")
// legend("Experimental","Model")
//  subplot(1,2,2)     
// bar(CI(5:7,1)',[CI(5:7,2) U(5:7)]) 
//  xlabel("% DVB")
// ylabel("Swelling Index (vol)")
//  legend("Experimental","Model")
