function pontos = softmax(x, temperatura)
    exp_x = exp(x / temperatura);
    soma_exp_x = sum(exp_x);
    pontos = exp_x / soma_exp_x;
endfunction

n = 5; // Número de pontos no vetor
soma_desejada = 1; // Soma desejada dos pontos
temperatura = 0.3; // Parâmetro de temperatura da função softmax

// Gere valores aleatórios para x (pode ser substituído por valores desejados)
x = rand(1, n);

// Obtenha os pontos usando a função softmax
pontos = softmax(x, temperatura) * soma_desejada;

// Mostrando o vetor criado
disp(pontos);
